import java.util.Scanner;

public class NQueensConstraint {
	    public static void main(String[] args) {
			Scanner sc = new Scanner(System.in);
			int K = sc.nextInt(); sc.nextLine();
			int N, qrow, qcol;
			
			for (int k = 0; k < K; k++) {
				N = sc.nextInt(); qrow = sc.nextInt(); 
				qcol = sc.nextInt(); sc.nextLine();
				findSol(N, qrow, qcol);
			}
    }
	
    //Try all permutations using backtracking
    public static void findSol(int N, int qr, int qc) {
        int[] a = new int[N + 2];
		a[N] = 0; a[N + 1] = 0;
        enumerate(a, 0, qr, qc);
		//System.out.printf("%d %d\n", a[N], a[N+1]);
		System.out.printf("%d\n", a[N+1]);
    }

    public static void enumerate(int[] q, int n, int qr, int qc) {
        int N = q.length - 2;
        if (n == N) { 
			q[N]++; //printQueens(q);
			if (q[qr] == qc) q[N + 1]++;
		}
        else {
            for (int i = 0; i < N; i++) {
                q[n] = i;
                if (isConsistent(q, n)) enumerate(q, n+1, qr, qc);
            }
        }
    }  

    //Return true if q[n] does not conflict with other queens q[0] through q[n-1]
    public static boolean isConsistent(int[] q, int n) {
        for (int i = 0; i < n; i++) {
            if (q[i] == q[n])             return false;   // same column
            if ((q[i] - q[n]) == (n - i)) return false;   // same major diagonal
            if ((q[n] - q[i]) == (n - i)) return false;   // same minor diagonal
        }
        return true;
    }

    //Print out N-by-N placement of queens from permutation q in ASCII.
    public static void printQueens(int[] q) {
        int N = q.length - 2;
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                if (q[i] == j) System.out.print("Q ");
                else           System.out.print("- ");
            }
            System.out.println();
        }  
        System.out.println();
    }
}
