import java.util.Scanner;

public class GoldCoins {
	    public static void main(String[] args) {
			Scanner sc = new Scanner(System.in);
			int K = sc.nextInt(); sc.nextLine();
			int S, M, N;
			
			for (int k = 0; k < K; k++) {
				S = sc.nextInt(); M = sc.nextInt(); sc.nextLine();
				N = sc.nextInt(); sc.nextLine();
				int [] V = new int[N];
				for (int i = 0; i < N; i++) V[i] = sc.nextInt();
				sc.nextLine();
				
				goldSum(S, M, V);
			}
    }
	
    private static void goldSum(int S, int M, int[] V) {
		int n = V.length;					
		//	T[i][k][m]--the number of distinct k-element subsets 
		//of {V[0], ..., V[i-1]} that sum to m. (1). First i-1 elements 
		//that sums to m is also clearly a subset of the first i elements 
		//that sums to m, thus, 	T[i][k][m] = T[i-1][k][m];
		//(2). Consider i-th element: if V[i] <= m, T[i][k][m] += T[i-1][k-1][m-V[i]],
		//which means if V[i-1] <= m, then by including the element V[i-1] as one
		//of the elements of the sum, it remains to find any (k-1)-
		//element subset of the first i-1 elements that sums to m - V[i-1].
		 
		// initialize T[0][*][*]
		long[][][] T = new long[n+1][M+1][S+1];
		for (int k = 0; k <= M; k++) {
			for (int m = 0; m <= S; m++) {
				T[0][k][m] = 0;	 //initialize
			}
		}
		T[0][0][0] = 1;		//empty set is one solution for beginning situation
										
		for (int i = 1; i <= n; i++) {		
			for (int k = 0; k <= M; k++) {
				for (int m = 0; m <= S; m++) {
					T[i][k][m] = T[i-1][k][m]; // solutions if we ignore V[i]
					if (k > 0 && m >= V[i-1]) {	// solutions if we use V[i]
						T[i][k][m] += T[i-1][k-1][m - V[i-1]];
					}
				}
			}
		}
		System.out.printf("%d\n", T[n][M][S]);
	}
}